#ifndef VERASCO_H_INCLUDED
#define VERASCO_H_INCLUDED

static int verasco_dummy(int x) { }

#define verasco_assume(b) if(b); else while(1)
#define verasco_assert(b) if(b); else verasco_dummy(__LINE__/0)

#ifdef REACH

#define verasco_reachable() do { int x = 0xdeadc0de / 0; } while(0)

#else

#define verasco_reachable()

#endif // ! REACH

static volatile long long verasco_any_int64_vol;
#define verasco_any_int64() verasco_any_int64_vol

#define verasco_any_int() ((int)verasco_any_int64_vol)
#define verasco_any_bool() (!verasco_any_int64_vol)

static volatile double verasco_any_double_vol;
#define verasco_any_double() verasco_any_double_vol

#define verasco_unroll(n) __builtin_annot("verasco_unroll",n);

# define DECLARE_MEMCPY(TYPE, MAX_LEN) \
  const TYPE* memcpy_##TYPE(TYPE* const dst, const TYPE* src, signed len) { \
    for (signed i = 0; i * sizeof(TYPE) < len; ++i) { \
      verasco_unroll ( MAX_LEN ); \
      dst[i] = src[i]; \
    } \
    return src; \
  }

#endif // ! VERASCO_H_INCLUDED
