#include"verasco.h"

void test1() {
  int a = verasco_any_int();
  int b = verasco_any_int();
  verasco_assume(a >= b);
  verasco_assume(-1000 < b);
  verasco_assume(a < 1000);
  /* Cooperation is needed to prove that no overflow occurs */
  verasco_assert(a-b >= 0);
}

/* This one involves cooperation of itv, congr and oct */
void test2() {
  int a = verasco_any_int();
  verasco_assume(0 <= a && a <= 13);
  int b = verasco_any_int();
  verasco_assume(-10000 <= b && b <= 10000);
  verasco_assume(a-b == 0);
  verasco_assume(a % 5 == 0);
  int c = b & 0xFFF;
  verasco_assert(0 <= c && c <= 10);
  verasco_assert(0 <= b && b <= 10);
}

void test3() {
  int a = verasco_any_int();
  verasco_assume(0 <= a && a <= 100);
  int b = a & 0xFF00;
  int c = verasco_any_int();
  verasco_assume(-1000 <= c && c <= 1000);
  verasco_assume(b-c <= 100);
  verasco_assert(c >= -100 && c <= 1000);
}

void test4() {
  int a = verasco_any_int();
  verasco_assume(-1000 <= a && a <= 1000);
  int b = a - a;
  verasco_assert(b == 0);
}

void test5() { }
void test6() { }

int main() {
  switch (verasco_any_int()) {
    case 1: test1(); break;
    case 2: test2(); break;
    case 3: test3(); break;
    case 4: test4(); break;
    case 5: test5(); break;
    case 6: test6(); break;
  }
  return 0;
}
